<template>
  <!-- 新增编辑 -->
  <a-modal
    :width="524"
    :maskClosable="false"
    :visible="props.visible"
    :confirm-loading="loading"
    :forceRender="true"
    :title="isUpdate ? '编辑应用链接分类' : '新建应用链接分类'"
    :body-style="{ paddingBottom: '8px' }"
    @update:visible="updateVisible"
    @ok="save"
    @close="updateVisible(false)"
  >
    <a-form ref="formRef" :model="form" :rules="rules" layout="vertical">
      <a-form-item label="应用链接分类名称:" name="categoryName">
        <a-input v-model:value="form.categoryName" allow-clear placeholder="请输入应用链接分类名称" />
      </a-form-item>
      <a-form-item label="分类排序:" name="fldSort">
        <a-input-number
          v-model:value="form.fldSort"
          :min="0"
          style="width: 100%"
          placeholder="请输入分类排序"
          allow-clear
          autocomplete="off"
        />
      </a-form-item>
    </a-form>
  </a-modal>
</template>

<script setup name="NewTypeAddEdit">
import { ref, onMounted, reactive } from 'vue';
import { message } from 'ant-design-vue';
import { AppTypeApi } from '../api/AppTypeApi';

const props = defineProps({
  visible: Boolean,
  data: Object,
  designId: String
});

const emits = defineEmits(['update:visible', 'done']);
// 弹框加载
const loading = ref(false);
// 是否是编辑状态
const isUpdate = ref(false);
// 表单数据
const form = ref({
  designId: props.designId,
  fldSort: 100
});
// 验证规则
const rules = reactive({
  categoryName: [{ required: true, message: '请输入应用链接分类名称', type: 'string', trigger: 'blur' }],
  fldSort: [{ required: true, message: '请输入分类排序', type: 'number', trigger: 'blur' }]
});
// ref
const formRef = ref(null);

onMounted(async () => {
  if (props.data) {
    isUpdate.value = true;
    getDetail();
  } else {
    isUpdate.value = false;
  }
});

const getDetail = async () => {
  const res = await AppTypeApi.detail({ categoryId: props.data.categoryId });
  form.value = Object.assign({}, res);
};

// 更改弹框状态
const updateVisible = value => {
  emits('update:visible', value);
};

// 点击保存
const save = async () => {
  await formRef.value.validate();
  // 修改加载框为正在加载
  loading.value = true;

  let result = null;

  // 执行编辑或修改
  if (isUpdate.value) {
    result = AppTypeApi.edit(form.value);
  } else {
    result = AppTypeApi.add(form.value);
  }
  result
    .then(async result => {
      // 移除加载框
      loading.value = false;

      // 提示添加成功
      message.success(result.message);
      // 关闭弹框，通过控制visible的值，传递给父组件
      updateVisible(false);

      // 触发父组件done事件
      emits('done');
    })
    .catch(() => {
      loading.value = false;
    });
};
</script>

<style></style>
